
#property copyright "Copyright  2011,"
#property link      ""
#include <stdlib.mqh>


//+------------------------------------------------------------------------------------------+
//| Pheonix External & Global Variables                                                      |
//+------------------------------------------------------------------------------------------+
   
   extern double     Lots             = 0.01       ;
   extern int        Slippage         = 6          ; 
   extern int        SL               = 400        ; 
   extern int        TP               = 400        ;  
   extern bool       StealthStop_On   = true       ;
   extern int        StealthStop      = 200        ;
   extern bool       TrailingStop_On  = true       ;   
   extern int        TrailingStop     = 200        ;       
   extern int        BBPeriod         = 20         ;
   extern int        BBDeviation      = 2          ;
   extern int        BBBandsShift     = 0          ;
   extern int        BBAppliedPrice   = 0          ;    
   extern int        BbZzMin          = 50         ;
   extern int        BbZzMax          = 300        ;
   extern int        MaPeriod         = 0          ;
   extern int        MaShift          = 0          ;
   extern int        MaMethod         = 0          ;
   extern int        AppliedPrice     = 0          ;
   
   
   bool       CloseLEn         = false      ;
   bool       CloseSEn         = false      ;
   bool       RedLEn           = false      ;
   bool       RedSEn           = false      ;   
   bool       YelloLEn         = false      ;
   bool       YelloSEn         = false      ;
   bool       GreenLEn         = false      ;
   bool       GreenSEn         = false      ;   
   string            PheonixState     = "Pheonix is Hunting" ;
   string            TradeBusy        = "No"       ;
   string            TradeAllowed     = "No"       ;
   string            Demo             = "No"       ;
   string            PheonixInit      = "No"       ;
   datetime          NewTime          = 0          ;   
   datetime          Bar1LCTi         = 0          ;
   datetime          Bar1SCTi         = 0          ;
   int               NewBar           = 0          ;   
   int               Total            = 0          ;
   int               Ticket           = 0          ; 
   int               cnt              = 0          ;
   int               MagicNumber      = 0          ;   
   double            Bar0Body         = 0          ;
   double            Bar1Body         = 0          ;
   double            Bar2Body         = 0          ;
   double            Bar3Body         = 0          ;
   double            Bar4Body         = 0          ;
   double            Bar5Body         = 0          ;
   double            Bar0LTL          = 0          ;
   double            Bar1LTL          = 0          ;
   double            Bar2LTL          = 0          ;
   double            Bar3LTL          = 0          ;
   double            Bar4LTL          = 0          ;
   double            Bar5LTL          = 0          ;
   double            Bar0UTL          = 0          ;
   double            Bar1UTL          = 0          ;
   double            Bar2UTL          = 0          ;
   double            Bar3UTL          = 0          ;
   double            Bar4UTL          = 0          ;
   double            Bar5UTL          = 0          ;   
   bool              Bar0Long         = false      ;
   bool              Bar0Short        = false      ;
   bool              Bar0Doji         = false      ;
   bool              Bar1Long         = false      ;
   bool              Bar1Short        = false      ;
   bool              Bar1Doji         = false      ;
   bool              Bar2Long         = false      ;
   bool              Bar2Short        = false      ;
   bool              Bar2Doji         = false      ;
   bool              Bar3Long         = false      ;
   bool              Bar3Short        = false      ;
   bool              Bar3Doji         = false      ;
   bool              Bar4Long         = false      ;
   bool              Bar4Short        = false      ;
   bool              Bar4Doji         = false      ;
   bool              Bar5Long         = false      ;
   bool              Bar5Short        = false      ;
   bool              Bar5Doji         = false      ;
   bool              Bar6Long         = false      ;
   bool              Bar6Short        = false      ; 
   bool              Bar6Doji         = false      ;     
   bool              Bar1LongHammer   = false      ;
   bool              Bar1ShortHammer  = false      ;
   bool              Bar1SStar        = false      ;
   bool              Bar2SStar        = false      ;
   bool              Bar3SStar        = false      ;   
   bool              Bar1Hammer       = false      ;
   bool              Bar2Hammer       = false      ;
   bool              Bar3Hammer       = false      ;  
   bool              BBUpL            = false      ;
   bool              BBUpS            = false      ;
   bool              BBUpE            = false      ;
   bool              BBMidL           = false      ;
   bool              BBMidS           = false      ;
   bool              BBMidE           = false      ;
   bool              BBLoT            = 0          ;
   bool              BbZzEn           = false      ;
   int               Bar1LXBbM        = 0          ;
   int               Bar1SXBbM        = 0          ;
   int               MaDir            = 0          ;   
   
//+------------------------------------------------------------------------------------------+
//| Pheonix Initialization Function                                                          |
//+------------------------------------------------------------------------------------------+  
 
   int init()
   {
//----
   
//----
   return(0);
   }
//+------------------------------------------------------------------------------------------+
//| Pheonix Deinitialization Function                                                        |
//+------------------------------------------------------------------------------------------+

   int deinit()
   {
//----
   
//----
   return(0);
   }
   
//+------------------------------------------------------------------------------------------+
//| Phoenix Start Function                                                                   |
//+------------------------------------------------------------------------------------------+    
   
   int start()
   {        
  
   if(Bars < 20)
   {
      Comment( "We need 100 bars, The Phoenix Is Off." );
      Print  ( "We need 100 bars, The Phoenix Is Off." );
   return(0);
   }
   
   int    digits = MarketInfo( Symbol( ), MODE_DIGITS );
   int    spread = MarketInfo( Symbol( ), MODE_SPREAD );
   
   if ( UninitializeReason() == 0 ) PheonixInit = "Yes"; 
   else PheonixInit = "No";
         
   if ( IsTradeContextBusy() == 1 ) TradeBusy = "Yes";
   else TradeBusy = "No";
      
   if ( IsLibrariesAllowed() == 1 ) TradeAllowed = "Yes";
   else TradeAllowed = "No";
   
   if ( IsDemo() == 1 ) Demo = "Yes";
   else Demo = "No";
      
//+------------------------------------------------------------------------------------------+
//| Phoenix Bar Delay Function                                                               |
//+------------------------------------------------------------------------------------------+     
  
// Identify new bars      
      
   if ( NewTime != Time[0])
   {
        NewTime  = Time[0];
        NewBar  ++        ;
   }   
   
//+------------------------------------------------------------------------------------------+
//| Variables                                                                                |
//+------------------------------------------------------------------------------------------+    
   
   if ( Symbol() == "EURUSD" ) MagicNumber = 11371000;
   if ( Symbol() == "GBPUSD" ) MagicNumber = 11371001; 
   if ( Symbol() == "USDJPY" ) MagicNumber = 11371002; 
   if ( Symbol() == "USDCHF" ) MagicNumber = 11371003;
   if ( Symbol() == "USDCAD" ) MagicNumber = 11371004;
   if ( Symbol() == "AUDUSD" ) MagicNumber = 11371005;
   if ( Symbol() == "NZDUSD" ) MagicNumber = 11371006;
   if ( Symbol() == "EURCHF" ) MagicNumber = 11371007; 
   if ( Symbol() == "EURJPY" ) MagicNumber = 11371008;
   if ( Symbol() == "EURGBP" ) MagicNumber = 11371009;
   if ( Symbol() == "EURCAD" ) MagicNumber = 11371010;
   if ( Symbol() == "EURAUD" ) MagicNumber = 11371011;
   if ( Symbol() == "EURNZD" ) MagicNumber = 11371012;
   if ( Symbol() == "GBPCHF" ) MagicNumber = 11371013;
   if ( Symbol() == "GBPJPY" ) MagicNumber = 11371014;
   if ( Symbol() == "GBPAUD" ) MagicNumber = 11371015;
   if ( Symbol() == "CADJPY" ) MagicNumber = 11371016;
   if ( Symbol() == "AUDJPY" ) MagicNumber = 11371017;
   if ( Symbol() == "AUDCAD" ) MagicNumber = 11371018;
   if ( Symbol() == "AUDNZD" ) MagicNumber = 11371019;
   if ( Symbol() == "AUDCHF" ) MagicNumber = 11371020;
   if ( Symbol() == "NZDJPY" ) MagicNumber = 11371021;
   if ( Symbol() == "CHFJPY" ) MagicNumber = 11371022;
   if ( Symbol() == "USDTRY" ) MagicNumber = 11371023;
   if ( Symbol() == "EURTRY" ) MagicNumber = 11371024;
   if ( Symbol() == "USDZAR" ) MagicNumber = 11371025;
   if ( Symbol() == "USDMXN" ) MagicNumber = 11371026;
   if ( Symbol() == "USDSGD" ) MagicNumber = 11371027;
   if ( Symbol() == "XAUUSD" ) MagicNumber = 11371028;
   if ( Symbol() == "XAGUSD" ) MagicNumber = 11371029;   
   
//+------------------------------------------------------------------------------------------+
//| Phoenix Gets Bar Information                                                             |
//+------------------------------------------------------------------------------------------+ 
   
   double Bar0Low   = iLow  (NULL,0,0);
   double Bar0High  = iHigh (NULL,0,0);
   double Bar0Open  = iOpen (NULL,0,0);
   double Bar0Close = iClose(NULL,0,0);
  
    
   double Bar1Low   = iLow  (NULL,0,1);
   double Bar1High  = iHigh (NULL,0,1);
   double Bar1Open  = iOpen (NULL,0,1);
   double Bar1Close = iClose(NULL,0,1);
   
   double Bar2Low   = iLow  (NULL,0,2);
   double Bar2High  = iHigh (NULL,0,2);
   double Bar2Open  = iOpen (NULL,0,2);
   double Bar2Close = iClose(NULL,0,2);
   
   double Bar3Low   = iLow  (NULL,0,3);
   double Bar3High  = iHigh (NULL,0,3);
   double Bar3Open  = iOpen (NULL,0,3);
   double Bar3Close = iClose(NULL,0,3);
   
   double Bar4Low   = iLow  (NULL,0,4);
   double Bar4High  = iHigh (NULL,0,4);
   double Bar4Open  = iOpen (NULL,0,4);
   double Bar4Close = iClose(NULL,0,4);
   
   double Bar5Low   = iLow  (NULL,0,5);
   double Bar5High  = iHigh (NULL,0,5);
   double Bar5Open  = iOpen (NULL,0,5);
   double Bar5Close = iClose(NULL,0,5);
   
   double Bar6Low   = iLow  (NULL,0,6);
   double Bar6High  = iHigh (NULL,0,6);
   double Bar6Open  = iOpen (NULL,0,6);
   double Bar6Close = iClose(NULL,0,6);   
   
   // Bars Are Long Or Short 
   if ( Bar0Open < Bar0Close ) Bar0Long  = true;
   else Bar0Long = false;   
   if ( Bar0Open > Bar0Close ) Bar0Short = true;
   else Bar0Short = false;   
   if ( Bar0Open == Bar0Close ) Bar0Doji = true;
   else Bar0Doji = false;   
   
   if ( Bar1Open < Bar1Close ) Bar1Long  = true;
   else Bar1Long = false;   
   if ( Bar1Open > Bar1Close ) Bar1Short = true;
   else Bar1Short = false;   
   if ( Bar1Open == Bar1Close ) Bar1Doji = true;
   else Bar1Doji = false;
   
   if ( Bar2Open < Bar2Close ) Bar2Long  = true;
   else Bar2Long = false;   
   if ( Bar2Open > Bar2Close ) Bar2Short = true;
   else Bar2Short = false;   
   if ( Bar2Open == Bar2Close ) Bar2Doji = true;
   else Bar2Doji = false;
   
   if ( Bar3Open < Bar3Close ) Bar3Long  = true;
   else Bar3Long = false;   
   if ( Bar3Open > Bar3Close ) Bar3Short = true;
   else Bar3Short = false;   
   if ( Bar3Open == Bar3Close ) Bar3Doji = true;
   else Bar3Doji = false;
   
   if ( Bar4Open < Bar4Close ) Bar4Long  = true;
   else Bar4Long = false;   
   if ( Bar4Open > Bar4Close ) Bar4Short = true;
   else Bar4Short = false;   
   if ( Bar4Open == Bar4Close ) Bar4Doji = true;
   else Bar4Doji = false;
   
   if ( Bar5Open < Bar5Close ) Bar5Long  = true;
   else Bar5Long = false;   
   if ( Bar5Open > Bar5Close ) Bar5Short = true;
   else Bar5Short = false;   
   if ( Bar5Open == Bar5Close ) Bar5Doji = true;
   else Bar5Doji = false;
   
   if ( Bar6Open < Bar6Close ) Bar6Long  = true;
   else Bar6Long = false;   
   if ( Bar6Open > Bar6Close ) Bar6Short = true;
   else Bar6Short = false;   
   if ( Bar6Open == Bar6Close ) Bar6Doji = true;
   else Bar6Doji = false;
   
   // Bars Body Lenght In Pips
   
   if ( Bar0Open < Bar0Close  ) Bar0Body = Bar0Close - Bar0Open ;
   if ( Bar0Open > Bar0Close  ) Bar0Body = Bar0Open  - Bar0Close;
   if ( Bar0Open == Bar0Close ) Bar0Body = 0 ;
   
   if ( Bar1Open < Bar1Close  ) Bar1Body = Bar1Close - Bar1Open ;
   if ( Bar1Open > Bar1Close  ) Bar1Body = Bar1Open  - Bar1Close;
   if ( Bar1Open == Bar1Close ) Bar1Body = 0 ;
   
   if ( Bar2Open < Bar2Close  ) Bar2Body = Bar2Close - Bar2Open ;
   if ( Bar2Open > Bar2Close  ) Bar2Body = Bar2Open  - Bar2Close;
   if ( Bar2Open == Bar2Close ) Bar2Body = 0 ;
   
   if ( Bar3Open < Bar3Close  ) Bar3Body = Bar3Close - Bar3Open ;
   if ( Bar3Open > Bar3Close  ) Bar3Body = Bar3Open  - Bar3Close;
   if ( Bar3Open == Bar3Close ) Bar3Body = 0 ;
   
   if ( Bar4Open < Bar4Close  ) Bar4Body = Bar4Close - Bar4Open ;
   if ( Bar4Open > Bar4Close  ) Bar4Body = Bar4Open  - Bar4Close;
   if ( Bar4Open == Bar4Close ) Bar4Body = 0 ;
   
   if ( Bar5Open < Bar5Close  ) Bar5Body = Bar5Close - Bar5Open ;
   if ( Bar5Open > Bar5Close  ) Bar5Body = Bar5Open  - Bar5Close;
   if ( Bar5Open == Bar5Close ) Bar5Body = 0 ;
   
   // Bars Lower Tail Length In Pips
   
   if ( Bar0Open < Bar0Close  ) Bar0LTL = Bar0Open  - Bar0Low;
   if ( Bar0Open > Bar0Close  ) Bar0LTL = Bar0Close - Bar0Low;
   if ( Bar0Open == Bar0Close ) Bar0LTL = Bar0Close - Bar0Low;
   
   if ( Bar1Open < Bar1Close  ) Bar1LTL = Bar1Open  - Bar1Low;
   if ( Bar1Open > Bar1Close  ) Bar1LTL = Bar1Close - Bar1Low;
   if ( Bar1Open == Bar1Close ) Bar1LTL = Bar1Close - Bar1Low;
   
   if ( Bar2Open < Bar2Close  ) Bar2LTL = Bar2Open  - Bar2Low;
   if ( Bar2Open > Bar2Close  ) Bar2LTL = Bar2Close - Bar2Low;
   if ( Bar2Open == Bar2Close ) Bar2LTL = Bar2Close - Bar2Low;
   
   if ( Bar3Open < Bar3Close  ) Bar3LTL = Bar3Open  - Bar3Low;
   if ( Bar3Open > Bar3Close  ) Bar3LTL = Bar3Close - Bar3Low;
   if ( Bar3Open == Bar3Close ) Bar3LTL = Bar3Close - Bar3Low;
   
   if ( Bar4Open < Bar4Close  ) Bar4LTL = Bar4Open  - Bar4Low;
   if ( Bar4Open > Bar4Close  ) Bar4LTL = Bar4Close - Bar4Low;
   if ( Bar4Open == Bar4Close ) Bar4LTL = Bar4Close - Bar4Low;
   
   if ( Bar5Open < Bar5Close  ) Bar5LTL = Bar5Open  - Bar5Low;
   if ( Bar5Open > Bar5Close  ) Bar5LTL = Bar5Close - Bar5Low;
   if ( Bar5Open == Bar5Close ) Bar5LTL = Bar5Close - Bar5Low;
   
   // Bars Upper Tail Lenght In Pips
   
   if ( Bar0Open < Bar0Close  ) Bar0UTL = Bar0High - Bar0Close;
   if ( Bar0Open > Bar0Close  ) Bar0UTL = Bar0High - Bar0Open ;
   if ( Bar0Open == Bar0Close ) Bar0UTL = Bar0High - Bar0Open ;
   
   if ( Bar1Open < Bar1Close  ) Bar1UTL = Bar1High - Bar1Close;
   if ( Bar1Open > Bar1Close  ) Bar1UTL = Bar1High - Bar1Open ;
   if ( Bar1Open == Bar1Close ) Bar1UTL = Bar1High - Bar1Open ;
   
   if ( Bar2Open < Bar2Close  ) Bar2UTL = Bar2High - Bar2Close;
   if ( Bar2Open > Bar2Close  ) Bar2UTL = Bar2High - Bar2Open ;
   if ( Bar2Open == Bar2Close ) Bar2UTL = Bar2High - Bar2Open ;
   
   if ( Bar3Open < Bar3Close  ) Bar3UTL = Bar3High - Bar3Close;
   if ( Bar3Open > Bar3Close  ) Bar3UTL = Bar3High - Bar3Open ;
   if ( Bar3Open == Bar3Close ) Bar3UTL = Bar3High - Bar3Open ;
   
   if ( Bar4Open < Bar4Close  ) Bar4UTL = Bar4High - Bar4Close;
   if ( Bar4Open > Bar4Close  ) Bar4UTL = Bar4High - Bar4Open ;
   if ( Bar4Open == Bar4Close ) Bar4UTL = Bar4High - Bar4Open ;
   
   if ( Bar5Open < Bar5Close  ) Bar5UTL = Bar5High - Bar5Close;
   if ( Bar5Open > Bar5Close  ) Bar5UTL = Bar5High - Bar5Open ;
   if ( Bar5Open == Bar5Close ) Bar5UTL = Bar5High - Bar5Open ;
   
   
   //if ( Bar1Body <= Bar1UTL && Bar1LTL <= Bar1UTL / 3 && Bar1Body <= SStarBody * Point ) Bar1SStar = true;   
   //if ( Bar2Body <= Bar2UTL && Bar2LTL <= Bar2UTL / 3 && Bar2Body <= SStarBody * Point ) Bar2SStar = true;   
   //if ( Bar3Body <= Bar3UTL && Bar3LTL <= Bar3UTL / 3 && Bar3Body <= SStarBody * Point ) Bar3SStar = true;   
    
   if ( Bar1Doji  ) Bar1SStar = true;   
   if ( Bar2Doji  ) Bar2SStar = true;   
   if ( Bar3Doji  ) Bar3SStar = true;   
   
  // if ( Bar1Body <= Bar1LTL && Bar1UTL <= Bar1LTL / 3 && Bar1Body <= HammerBody * Point  ) Bar1Hammer = true;  
   //if ( Bar2Body <= Bar2LTL && Bar2UTL <= Bar2LTL / 3 && Bar2Body <= HammerBody * Point  ) Bar2Hammer = true;  
   //if ( Bar3Body <= Bar3LTL && Bar3UTL <= Bar3LTL / 3 && Bar3Body <= HammerBody * Point  ) Bar3Hammer = true;
  
   if ( Bar1Doji && Bar1UTL <= 1 * Point ) Bar1Hammer = true;  
   if ( Bar2Doji && Bar2UTL <= 1 * Point ) Bar2Hammer = true;  
   if ( Bar3Doji && Bar3UTL <= 1 * Point ) Bar3Hammer = true;
  
   
//+------------------------------------------------------------------------------------------+
//| Phoenix Gets Indicator Information                                                       |
//+------------------------------------------------------------------------------------------+
     
   // Bollinger Bands
   
   double Bb1VT = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,1 ,1);
   double Bb2VT = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,1 ,2);
   double Bb3VT = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,1 ,3);
   double Bb4VT = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,1 ,4);
   double Bb5VT = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,1 ,5);
   double Bb6VT = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,1 ,6);
   
   
   double Bb1VM  = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,0 ,1);
   double Bb2VM  = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,0 ,2);
   double Bb3VM  = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,0 ,3);
   double Bb4VM  = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,0 ,4);
   double Bb5VM  = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,0 ,5);
   double Bb6VM  = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,0 ,6);
   
   double Bb1VB = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,2 ,1);
   double Bb2VB = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,2 ,2);
   double Bb3VB = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,2 ,3);
   double Bb4VB = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,2 ,4);  
   double Bb5VB = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,2 ,5);
   double Bb6VB = iBands( NULL, 0, BBPeriod, BBDeviation, BBBandsShift, BBAppliedPrice,2 ,6);  
    
   
   //double BBUpperTop    = ( Bb1VT + BBZonePips * Point );
   //double BBUpperBottom = ( Bb1VT - BBZonePips * Point );
   //double BBMainTop     = ( Bb1VM + BBZonePips * Point );
   //double BBMainBottom  = ( Bb1VM - BBZonePips * Point );   
   //double BBLowerTop    = ( Bb1VB + BBZonePips * Point );
   //double BBLowerBottom = ( Bb1VB - BBZonePips * Point );   
   
   //double Bb1D = Bb1VT - Bb1VB;
   //double Bb2D = Bb2VT - Bb2VB;
   //double Bb3D = Bb3VT - Bb3VB;
   //double Bb4D = Bb4VT - Bb4VB;
   //double Bb5D = Bb5VT - Bb5VB;
   //double Bb6D = Bb6VT - Bb6VB;
   
   
   // Moving Average
   double Bar0MaV = iMA( NULL, 0, MaPeriod, MaShift, MaMethod, AppliedPrice, 0 );
   double Bar1MaV = iMA( NULL, 0, MaPeriod, MaShift, MaMethod, AppliedPrice, 1 );
   double Bar2MaV = iMA( NULL, 0, MaPeriod, MaShift, MaMethod, AppliedPrice, 2 );
   double Bar3MaV = iMA( NULL, 0, MaPeriod, MaShift, MaMethod, AppliedPrice, 3 );
   double Bar4MaV = iMA( NULL, 0, MaPeriod, MaShift, MaMethod, AppliedPrice, 4 );
   double Bar5MaV = iMA( NULL, 0, MaPeriod, MaShift, MaMethod, AppliedPrice, 5 );   
   double Bar6MaV = iMA( NULL, 0, MaPeriod, MaShift, MaMethod, AppliedPrice, 6 );
    
   // Moving Average MaDir
   
   double Trend1n3  = (Bb1VM - Bb3VM);
   double Trend4n6  = (Bb4VM - Bb6VM);
   
   
   if ( Trend1n3 <=   3 * Point  ) CloseLEn = True;
   else CloseLEn = false;
   
   if ( Trend1n3 >=  -3 * Point  ) CloseSEn = True;
   else CloseSEn = false;
   
   if ( Trend1n3 <=  9 * Point   ) RedLEn = True;
   else RedLEn = false;
   
   if ( Trend1n3 >= -9 * Point   ) RedSEn = True;
   else RedSEn = false;
   
   if ( Trend1n3 <=  18 * Point  ) YelloLEn = True;
   else YelloLEn  = false;
   
   if ( Trend1n3 >=  -18 * Point ) YelloSEn = True;
   else YelloSEn  = false;
   
   if ( Trend1n3 <=   36 * Point ) GreenLEn = True;
   else GreenLEn  = false;
   
   if ( Trend1n3 >=  -36 * Point ) GreenSEn = True;
   else GreenSEn  = false;
   
   
   
      
   if ( Bar1MaV <  Bar0MaV ) MaDir =  1;
   if ( Bar1MaV == Bar0MaV ) MaDir =  0;
   if ( Bar1MaV >  Bar0MaV ) MaDir = -1;     
 
//+------------------------------------------------------------------------------------------+
//| Phoenix AI                                                                               |
//+------------------------------------------------------------------------------------------+   
   
   // Current Price Average
   
   double ThePrice = ( ( Ask + Bid ) / 2 );   
   
   // Limit Orders to Bollinger Band Width
      
   //if ( Bb1D < ( BbZzMax * Point ) && Bb1D > (BbZzMin * Point )) BbZzEn = true;
   //else BbZzEn = false;   
    
   
   
   
   
   
//+------------------------------------------------------------------------------------------+
//| Phoenix Data To Display                                                                  |
//+------------------------------------------------------------------------------------------+       

   Comment ("\n",
            "\n","Phoenix Is----------- =",  PheonixState,
            "\n","Bar Delay----------- =",  NewBar,
            "\n","Is Trade Allowed- =",  TradeAllowed,
            "\n","Is Trade Busy----- =",  TradeBusy,
            "\n","Is Phoenix Init----- =",  PheonixInit,
            "\n","Demo Mode-------- =",  Demo,                     
            "\n","Spread--------------- =",  MODE_SPREAD * Point,            
            "\n","Acc. Balance------- =",  AccountBalance(), 
            "\n","FreeMargin--------- =",  AccountFreeMargin(),
            "\n","Order Profit-------- =",  OrderProfit(),
            "\n","Stop Loss----------- =", 
            "\n","Take Profit--------- =", 
            "\n","Upper Long--------- =", 
            "\n","Close-------- =", 
            "\n","Red--------- =",                
            "\n","Yello-------- =",                         
            "\n","Green------ =",   MagicNumber,
            "\n");      
   
//+------------------------------------------------------------------------------------------+
//| Phoenix Order Management                                                                 |
//+------------------------------------------------------------------------------------------+      
   
  Total=OrdersTotal();
  RefreshRates();
   if(Total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(50*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
       if( Bar0Open > Bar1Open && Bar1Long && Bar2Low < Bb2VB && NewBar > 1 && MaDir > 0 && Trend1n3 > -4 )// Go Long       
        {
         Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"macd sample",MagicNumber,0,Green);
         if(Ticket>0)
           {
            if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
            NewBar = 0;        
            
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if ( Bar0Open < Bar1Open && Bar1Short && Bar2High > Bb2VT && NewBar > 1 && MaDir < 0 && Trend1n3 < 4 )// Go Short           
        {
         Ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"macd sample",MagicNumber,0,Red);
         if(Ticket>0)
           {
            if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))            
            NewBar = 0;           
            
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }   
    
     
     
//+------------------------------------------------------------------------------------------+
//| Phoenix  Close Long                                                                      |
//+------------------------------------------------------------------------------------------+     
   
   if ((OrdersTotal() > 0 && (Bar2UTL / 2) > Bar2Body && Bar2High > Bb1VT && Bar1Short )||
       ( ThePrice < OrderOpenPrice() - ( StealthStop * Point ) && StealthStop_On  ))    
   {
      for (cnt = OrdersTotal(); cnt >= 0; cnt--) {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY)
         OrderClose(OrderTicket(), OrderLots(),Bid,3,Violet);
      }
   }
   
//+------------------------------------------------------------------------------------------+
//| Phoenix  Close Short                                                                     |
//+------------------------------------------------------------------------------------------+  
   
   if ((OrdersTotal() > 0 && (Bar2LTL / 2) > Bar2Body && Bar2Low < Bb1VB && Bar1Long )||
       ( ThePrice > OrderOpenPrice() + ( StealthStop * Point ) && StealthStop_On ))    
   {
      for (cnt = OrdersTotal(); cnt >= 0; cnt--) {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) 
         OrderClose(OrderTicket(), OrderLots(),Ask,3,Violet);
      }
   }
   
//+------------------------------------------------------------------------------------------+
//| Phoenix  Trailing Stop                                                                    |
//+------------------------------------------------------------------------------------------+     





   
   
   
   
   
   
   
   
   
   
   
   
  
            

//+------------------------------------------------------------------------------------------+
//| Phoenix End Program                                                                      |
//+------------------------------------------------------------------------------------------+  
         
   return(0);
     }
// the end.       
         
   
 